# coding: utf-8


"""
IGNORE:
    Nutanix Lcm Versioned APIs

    Manage Infrastructure, Software and Firmware Upgrades.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_lcm_py_client.Ntnx.lcm.v4.common.LcmEntityType import LcmEntityType  # noqa: F401,E501
from ntnx_lcm_py_client.Ntnx.lcm.v4.resources.EntityInstance import EntityInstance  # noqa: F401,E501
from ntnx_lcm_py_client.Ntnx.lcm.v4.resources.OperationEnv import OperationEnv  # noqa: F401,E501

"""
IGNORE:
NOTE: This class is auto generated by the swagger code generator program.

Do not edit the class manually.
IGNORE
"""


class EntityInfo(object):
    """EntityInfo - a model defined in Swagger"""
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """ # noqa: E501
    swagger_types = {
        'entity_type': 'lcm.v4.common.LcmEntityType',
        'entity_class': 'str',
        'entity_model': 'str',
        'op_environment': 'lcm.v4.resources.OperationEnv',
        'child_entities': 'str',
        'instances': 'list[lcm.v4.resources.EntityInstance]',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'entity_type': 'entityType',
        'entity_class': 'entityClass',
        'entity_model': 'entityModel',
        'op_environment': 'opEnvironment',
        'child_entities': 'childEntities',
        'instances': 'instances',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, entity_type=None, entity_class=None, entity_model=None, op_environment=None, child_entities=None, instances=None, *args, **kwargs):  # noqa: E501
        """EntityInfo - a model defined in Swagger
            \nInformation about an LCM entity affected by the operation.
        """
        self.__entity_type = None
        self.__entity_class = None
        self.__entity_model = None
        self.__op_environment = None
        self.__child_entities = None
        self.__instances = None
        self.discriminator = None
        if entity_type is not None:
            self.__entity_type = entity_type
        if entity_class is not None:
            self.__entity_class = entity_class
        if entity_model is not None:
            self.__entity_model = entity_model
        if op_environment is not None:
            self.__op_environment = op_environment
        if child_entities is not None:
            self.__child_entities = child_entities
        if instances is not None:
            self.__instances = instances
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'lcm.v4.resources.EntityInfo'

    def _initialize_fq_object_type(self):
        return 'lcm.v4.r0.a1.resources.EntityInfo'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def entity_type(self):
        """`{ lcm.v4.common.LcmEntityType }`
            
        """ # noqa: E501
        return self.__entity_type

    @entity_type.setter
    def entity_type(self, entity_type):

        self.__entity_type = entity_type

    @property
    def entity_class(self):
        """`{ str }`
            \nLCM entity class
        """ # noqa: E501
        return self.__entity_class

    @entity_class.setter
    def entity_class(self, entity_class):

        self.__entity_class = entity_class

    @property
    def entity_model(self):
        """`{ str }`
            \nLCM entity model
        """ # noqa: E501
        return self.__entity_model

    @entity_model.setter
    def entity_model(self, entity_model):

        self.__entity_model = entity_model

    @property
    def op_environment(self):
        """`{ lcm.v4.resources.OperationEnv }`
            
        """ # noqa: E501
        return self.__op_environment

    @op_environment.setter
    def op_environment(self, op_environment):

        self.__op_environment = op_environment

    @property
    def child_entities(self):
        """`{ str }`
            \nDetailed information for the LCM entity. For example, firmware entities contain additional information about NIC and so on
        """ # noqa: E501
        return self.__child_entities

    @child_entities.setter
    def child_entities(self, child_entities):

        self.__child_entities = child_entities

    @property
    def instances(self):
        """`{ list[lcm.v4.resources.EntityInstance] }`
            
        """ # noqa: E501
        return self.__instances

    @instances.setter
    def instances(self, instances):

        self.__instances = instances

    @property
    def _reserved(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """`{ str }`
            
        """ # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """`{ dict(str, object) }`
            
        """ # noqa: E501
        return self.__dollar_unknown_fields

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(EntityInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EntityInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

